/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.lustin.changed;

/**
 *
 * @author lustin, fterm
 */
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Vector;

public interface Ticket

{
    public interface TicketProperty{
        Vector getAll();
        Hashtable get(String name);
        Integer delete(String name);
        Integer create(String name, Hashtable attributes);
        Integer update(String name, Hashtable attributes);
        
    }
    public interface Milestone  extends TicketProperty {   }
    public interface Severity{
    	Vector getAll();
    	String get(String name);
    	Integer delete(String name);
    	Integer create(String name, String attributes);
    	Integer update(String name, String attributes);
    }
    public interface Type{
    	Vector getAll();
		String get(String name);
		Integer delete(String name);
		Integer create(String name, String attributes);
		Integer update(String name, String attributes);
    }
    public interface Resolution{
       	Vector getAll();
		String get(String name);
		Integer delete(String name);
		Integer create(String name, String attributes);
		Integer update(String name, String attributes);//extends TicketProperty {    }
    }
    public interface Priority{
       	Vector getAll();
		String get(String name);
		Integer delete(String name);
		Integer create(String name, String attributes);
		Integer update(String name, String attributes);
    } //  extends TicketProperty {    }
    public interface Component  extends TicketProperty {    }
    public interface Version    extends TicketProperty {    }
    public interface Status{
       	Vector getAll();
		String get(String name);
		Integer delete(String name);
		Integer create(String name, String attributes);
		Integer update(String name, String attributes);
    }

    Vector query(); // qstr="status!=closed"
    Vector query(String qstr);
    
    Integer delete(Integer id);
    
    Integer create( String summary, String description);
    Integer create( String summary, String description, Hashtable attribute);
    Integer create( String summary, String description, Hashtable attribute, Boolean notify);
    
    Vector get(Integer id);
  
    Vector update(Integer id, String comment);
    Vector update(Integer id, String comment, Hashtable attributes);
    Vector update(Integer id, String comment, Hashtable attributes, Boolean notify);
    
    Hashtable changeLog(Integer id);
    Hashtable changeLog(Integer id, Integer when);
    
    Vector listAttachments(Integer ticket);
    
    byte[] getAttachment(Integer ticket, String filename);
    
    String putAttachment(Integer ticket, String filename, String description, byte[] data);
    String putAttachment(Integer ticket, String filename, String description, byte[] data, Boolean replace);
    
    Boolean deleteAttachment(Integer ticket, String filename);
    
    Vector<HashMap> getTicketFields();
}

